library nest_jsx_query_builder;

class NestJsxQueryBuilder {

  ///Use this method to create `or` query with n condition
  static Map<String, dynamic> or(List<Map<String, dynamic>> conditionsMap) {
    String fullConditionsResult = "";

    fullConditionsResult = _buildFullConditionString(conditionsMap);

    return {
      "\"\$or\"": [fullConditionsResult]
    };
  }

  ///Use this method to create `and` query with n condition
  static Map<String, dynamic> and(List<Map<String, dynamic>> conditionsMap) {
    String fullConditionsResult = "";

    fullConditionsResult = _buildFullConditionString(conditionsMap);

    return {
      "\"\$and\"": [fullConditionsResult]
    };
  }

  ///This method creates a condition string from the passed map
  static String _buildFullConditionString(
      List<Map<String, dynamic>> conditionsMap) {
    String fullConditionsResult = "";

    for (int i = 0; i < conditionsMap.length; i++) {
      Map<String, dynamic> condition = conditionsMap[i];

      String conditionPropertyName;

      ///add quotation only when the first part doesn't start with quotation
      if (condition.keys.first.startsWith("\"")) {
        conditionPropertyName = "${condition.keys.first}";
      } else {
        conditionPropertyName = "\"${condition.keys.first}\"";
      }

      dynamic conditionValue = "${condition[condition.keys.first]}";

      String conditionString = "{$conditionPropertyName: $conditionValue}";

      if (fullConditionsResult.isEmpty)
        fullConditionsResult = conditionString;
      else
        fullConditionsResult = "$fullConditionsResult,$conditionString";
    }

    return fullConditionsResult;
  }
}

